function Example00a
% this tests the scaling law on the five-point star
clear all 
close all
close all
clear all
global RBFscale
global RBFtype
global RBFpar
global RBFfactor
d=2;
m=4; % a higher order than 4 will not work because 
% polynomial exactness is violated
RBFtype='tp'
RBFsign=(-1)^(1+m-d/2)
RBFfactor=RBFsign/(2^(2*m-1)*pi^(d/2)*factorial(m-1)*factorial(m-d/2)) 
RBFscale=1
RBFpar=2*m-d  % paper: 2*m-d>4, RBFpar=2*m-d even >4
h=1;
for i=1:155
    locpts=[[0 0]; [0 1]; [1 0]; [-1 0]; [0 -1] ]*h; % local stencil
    sc=-[4 -1 -1 -1 -1]'/(h*h); % weights
    pol=polynomials(locpts,4); % polynomial values 
    % prepare for quadratic form.
    AXX=kermat(locpts,locpts)*RBFfactor;
    ALX=laplacekermat(locpts, [0 0])*RBFfactor;
    ALL=laplaceXYkermat([0 0],[0 0])*RBFfactor;
    % the quadratic form
    QFa(i)=ALL-2*ALX'*sc+sc'*AXX*sc; % quadratic form for 5-point star
    Qfb(i)=h^(2*m-d-4); % scaling law 
    hlist(i)=h;
    h=h*0.9;
end
% The plot should show two parallel lines of O(h) behavior. 
loglog(hlist, sqrt(QFa), hlist, sqrt(Qfb))
