function Example01
% just the five-point star, test stability and consistency, regular grid,
% only the partial matrix used
close all
clear all
global RBFscale
global RBFtype
global RBFpar
global RBFfactor
RBFtype='ms' % 
RBFscale=1 %
RBFpar=3% =m-d/2, so m=RBFpar+1 in 2D for type = ms
m=RBFpar+1
RBFfactor=2^(1-m)/gamma(m) % as in theory, see Wendland's book
% get all points
hlist=[0.5 0.25 0.125 0.0625];
for hk=1:length(hlist)
    h=hlist(hk);
    [xp, yp]=meshgrid(-1:h:1,-1:h:1);
    pts=[xp(:) yp(:)];
    npts=length(pts(:,1));
    figure
    plot(pts(:,1),pts(:,2),'.');
    axis square
    ibnd1=find((abs(pts(:,1))>=1-eps)); % 
    ibnd2=find((abs(pts(:,2))>=1-eps)); % 
    ibnd=union(ibnd1, ibnd2);
    hold on
    plot(pts(ibnd,1),pts(ibnd,2),'rx');
    iint=setdiff((1:npts)',ibnd);
    plot(pts(iint,1),pts(iint,2),'go');
    nint=length(iint);
    A=zeros(npts, npts);
    for k=1:nint
        ik=iint(k); % index of interior point in pts
        ds=distsqh(pts,pts(ik,:));
        [ms is]=sort(ds); 
        nlist=is(2:5); % the four closest neighbors
        A(ik,ik)=-4/(h*h);
        for j=2:5
            A(ik,is(j))=1/(h*h);
        end
    end
    % we do NOT insert the boundary bart here,
    % and do everything on the matrix A(iint,iint).
    pA=-inv(A(iint,iint));
    snorm=norm(pA,Inf);
    figure
    spy(sparse(A(iint,iint)));
    figure
    mesh(pA);
    cA=condest(A(iint,iint)');
    nA=norm(A(iint,iint),Inf);
    cnA=cA/nA;  % estimated via condition 
    locpts=[[0 0]; [0 1]; [1 0]; [-1 0]; [0 -1] ]*h;
    sc=-[4 -1 -1 -1 -1]'/(h*h);
    AXX=kermat(locpts,locpts)*RBFfactor;
    ALX=laplacekermat(locpts, [0 0])*RBFfactor;
    ALL=laplaceXYkermat([0 0],[0 0])*RBFfactor;
    QFa=ALL-2*ALX'*sc+sc'*AXX*sc;
    erna=sqrt(QFa);
    sb=AXX\ALX;
    QFb=ALL-2*ALX'*sb+sb'*AXX*sb;
    ernb=sqrt(QFb);
    prod=snorm*erna;
    % [nint h snorm erna prod]
    % disp(sprintf('%d & %6.4f & %f &  %f & %f & %f \\\\',nint, h, snorm, cnA, erna, prod))
    disp(sprintf('%d & %6.4f & %f &   %f & %f \\\\',nint, h, snorm, erna, prod))
end
return
