function Example03
% compare the five-point star with corner 
% approx. on the regular grid 
close all
clear all
global RBFscale
global RBFtype
global RBFpar
global RBFfactor
m=4
d=2
format long g
RBFtype='tp'
RBFsign=(-1)^(1+m-d/2)
RBFfactor=RBFsign/(2^(2*m-1)*pi^(d/2)*factorial(m-1)*factorial(m-d/2)) 
RBFscale=1
RBFpar=2*m-d  % paper: 2*m-d>4, RBFpar=2*m-d even >4
q=4
h=1;
locpts=[[0 0]; [0 1]; [1 0]; [-1 0]; [0 -1] ]*h;
sc=-[4 -1 -1 -1 -1]'/(h*h);
AXX=kermat(locpts,locpts)*RBFfactor;
ALX=laplacekermat(locpts, [0 0])*RBFfactor;
ALL=laplaceXYkermat([0 0],[0 0])*RBFfactor;
% the quadratic form for the 5-point star, for comparidson
QF5=ALL-2*ALX'*sc+sc'*AXX*sc;
% and the error
erna5p=sqrt(QF5)
% We shall work on a NxN grid, for varying N
Nstart=3;
for N=Nstart:15
    % the Laplacian is evaluated at zero, and the 
    % boundary is with x=-1 y=-1. Thus we work on [-1,N-1]^2
    [xp, yp]=meshgrid(-1:N-1,-1:N-1);
    pts=[xp(:) yp(:)];
    npts=length(pts(:,1));
%     figure
%     plot(pts(:,1),pts(:,2),'x',0,0,'ro')
% now calculate the optimal stencil 
    AXX=kermat(pts,pts)*RBFfactor;
    polvalues=polynomials(pts,q);
    nq=length(polvalues(1,:));
    Afull=[AXX polvalues; polvalues' zeros(nq,nq)];
    % the rhs for the Laplacian on the monomials at zero
    polrhs=zeros(nq,1);
    % 2 on x^2 and y^2, else zero
    polrhs(4)=2;
    polrhs(6)=2;
    ALX=laplacekermat(pts, [0 0])*RBFfactor;
    rhs=[ALX; polrhs];
    ALL=laplaceXYkermat([0 0],[0 0])*RBFfactor;
    % now the full solution
    scfull=Afull\rhs;
    % but the stencil coefficients are only the upper part
    sc=scfull(1:npts);
    % we calculate the polynomial reproduction (exactness)
    % It should be zero except for roundoff
    polrep(N)=norm(sc'*polvalues-polrhs',Inf);
    % the quadratic form, calculated in two ways, for testing
    % QFb=ALL-2*ALX'*sc+sc'*AXX*sc
    QFa=ALL-2*rhs'*scfull+scfull'*Afull*scfull;
    % and the error
    erna(N)=sqrt(QFa); % error noem
    Nlist(N)=N*N; % number of offered nodes 
%     figure
%     surf(xp, yp, reshape(sc,size(xp)))
end
figure
surf(xp, yp, reshape(sc,size(xp)))
figure
plot(Nlist(Nstart:end),erna(Nstart:end))
xlabel('Number of points')
ylabel('Consistency error')
figure
plot(polrep(Nstart:end))
title('Exactness on polynomials')
% the norms
erna'
% the final number of nodes
Nlist(end)
return

